#include <stdio.h>
#include <math.h>

struct complex 
{
    double real;
    double image;
};


void print_complex(const struct complex *cl)
{
    if(cl->real == 0.0 && cl->image == 0.0) {
        printf("0");
    } else if(cl->real == 0) {
        printf("( %lgi )", cl->image);
    } else if(cl->image == 0){
        printf("( %lg )", cl->real);
    } else {
        printf("( %lg%+lgi )", cl->real, cl->image);
    }
}

void plus_complex(const struct complex *c1, const struct complex *c2)
{
    struct complex result; 
    
    result.real = c1->real + c2->real;
    result.image = c1->image + c2->image;

    print_complex(c1);
    printf(" + ");
    print_complex(c2);
    printf(" = ");
    print_complex(&result);
    printf("\n");
}

void minus_complex(const struct complex *c1, const struct complex *c2)
{
    struct complex result; 
    
    result.real = c1->real - c2->real;
    result.image = c1->image - c2->image;
    
    print_complex(c1);
    printf(" - ");
    print_complex(c2);
    printf(" = ");
    print_complex(&result); 
    printf("\n");
}

void multiple_complex(const struct complex *c1, const struct complex *c2)
{
    struct complex result;
    
    result.real = c1->real * c2->real + c1->image * c2->image * -1.0;
    result.image = c1->real * c2->image + c1->image * c2->real;
    
    print_complex(c1);
    printf(" - ");
    print_complex(c2);
    printf(" = ");
    print_complex(&result); 
    printf("\n");
}

void abs_complex(const struct complex *c)
{
    double value = sqrt(c->real * c->real + c->image * c->image);
    
    printf("|");
    print_complex(c);
    printf("| = %lg\n", value);
}

int main(int argc, char **argv)
{
    struct complex c1 = {2.5, 2.6}, c2 = {-3.3, -2.5};

    printf("더하기\n");
    plus_complex(&c1, &c2);
    
    printf("빼기\n");
    minus_complex(&c1, &c2);
    
    printf("곱하기\n");
    multiple_complex(&c1, &c2);
    
    printf("절대값\n");
    abs_complex(&c1);
    abs_complex(&c2);
    
    return 0;
}
